<?php

$racine_blog = dirname(__FILE__).'/../../../';

/*** Création dossier ***/
function dossier()
{
	global $chemin_dossier_image, $racine_blog;
	
	chdir($racine_blog);
	$dossiers_image = explode("/",$chemin_dossier_image); //met le chemin dans un tableau
	
	for ($i=0;$i<count($dossiers_image);$i++)

	{
		$dossier = $chemin.$dossiers_image[$i];
		$chemin = $dossier."/";
		if (!is_dir($chemin)) {
			mkdir ($chemin);
			chmod ($chemin, 0755);
		}
	}
}	

/*** Création miniature ***/
function miniature($orig, $min,$resoL,$resoH) //Orignial, Miniature, resolution max horizontal, resolution max vertical
{
	global $img_click,$typejpg,$typegif,$typepng;
	
	$type =  substr(strrchr($orig, '.'), 1);

	if (in_array($type,$typejpg))
		{	$origtmp = ImageCreateFromJpeg($orig);	}	//les jpeg
	elseif (in_array($type,$typegif))
		{	$origtmp = ImageCreateFromGif($orig);	}	//les gif
	elseif (in_array($type,$typepng))
		{	$origtmp = ImageCreateFromPng($orig);	}	// les png
	else	
		{	exit("erreur dans la fonction miniature() : extention inconnue");	}
	
	$Lorig = imagesx($origtmp);
	$Horig = imagesy($origtmp);
	
	if ($Lorig <= $resoL && $Horig <= $resoH)
	{
		$img_click = false;
	}
	else
	{
		$img_click = true;
		//trouver les dimensions de la nouvelle image
		if ($Lorig <= ($resoL / $resoH * $Horig)) {
			$Hmin = $resoH;
			$Lmin = ($resoH / $Horig) * $Lorig;
		} else {
			$Lmin = $resoL;
			$Hmin = ($resoL / $Lorig) * $Horig;
		}
		$imgtmp = ImageCreateTrueColor ($Lmin, $Hmin) 
			or die ("Erreur lors de la création de l'image");
		
		ImageCopyResampled($imgtmp, $origtmp, 0, 0, 0, 0, $Lmin, $Hmin, $Lorig, $Horig);
		ImageString($imgtmp, 0, 12, $hauteurDestination-18, "$fichierSource - ($largeurSource x $hauteurSource)", $blanc);
		
		if (($type == 'jpeg')||($type == 'jpg'))
			{	ImageJpeg($imgtmp, $min);	}	//les jpeg
		elseif ($type == ('gif'))
			{	ImageGif($imgtmp, $min);	}		//les gif
		else
			{	ImagePng($imgtmp, $min);	}	//les png
	}
}

/*** Envoie fichier venant du disque dur ***/
function envoi($fichier)
{
	global $extensions_ok, $chemin_dossier_image, $taille_max, $racine_blog,$min_reso_H,$min_reso_V,$reduct_orig,$orig_reso_H,$orig_reso_V;
	
	chdir($racine_blog);
	$dest_dossier = $chemin_dossier_image.'/';
	$itisimg = 1; //c'est une image (initialisation de la variable)


	// vérifications de l'extention
	if( !in_array( substr(strrchr($_FILES[$fichier]['name'], '.'), 1), $extensions_ok ) )
	{
		$msgerreur = "[Erreur]    N'est pas un fichier de type png, gif ou jpg !";
		$erreur = $erreur + 1;
		$itisimg = 0;
	}
	// vérification de la taille max
	elseif( file_exists($_FILES[$fichier]['tmp_name'])
		and filesize($_FILES[$fichier]['tmp_name']) > $taille_max)
	{
		$msgerreur = '[Erreur]    Fichier plus gros que '.($taille_max/1048576).'Mo !';
		$erreur = $erreur + 1;
		$itisimg = 0;
	}
	
	// si c'est une image envoie et reduction de l'image
	if($itisimg == 1)
	{
		//modif de variable serveur (marche pas chez free.fr)
		ini_set('memory_limit', $taille_max); // en octets
		//set_time_limit(3600); // en secondes
		
		// COPIE FICHIER
		$dest_fichier = basename($_FILES[$fichier]['name']);
		// nettoyage nom fichier
		// enlever les accents
		$dest_fichier = strtr($dest_fichier,
			'ÀÁÂÃÄÅÇÈÉÊËÌÍÎÏÒÓÔÕÖÙÚÛÜÝàáâãäåçèéêëìíîïðòóôõöùúûüýÿ',
			'AAAAAACEEEEIIIIOOOOOUUUUYaaaaaaceeeeiiiioooooouuuuyy');
		// remplacer les caracteres autres que lettres, chiffres et point par _
		$dest_fichier = preg_replace('/([^.a-z0-9]+)/i', '_', $dest_fichier);
		// copie du fichier
		$orig = $dest_dossier . $dest_fichier;
		move_uploaded_file($_FILES[$fichier]['tmp_name'], $orig);
		// creation de la miniature
		$min = $dest_dossier.'mini_'.$dest_fichier;
		miniature($orig, $min,$min_reso_H,$min_reso_V);
		// reduction de l'original si nececaire
		if ($reduct_orig == "checked")
		{
			$origtmp = $dest_dossier.'tmp_'.$dest_fichier;
			miniature($orig, $origtmp,$orig_reso_H,$orig_reso_V);
			unlink($orig);
			rename($origtmp,$orig);
			unlink($origtmp);
		}
		//modif des permissions	
		chmod ($orig,0644);
		chmod ($min,0644);
		$msgerreur = "[OK]        Envoi et reduction effectués";
		
		lien($orig,$min);
	}
	else {echo $msgerreur;}
}

/*** Copie de fichier venant d'internet ***/
function copier($img_web)
{
	global $extensions_ok, $chemin_dossier_image, $taille_max, $racine_blog,$min_reso_H,$min_reso_V,$reduct_orig,$orig_reso_H,$orig_reso_V;
	
	chdir($racine_blog);
	//$chemin = $_SERVER['DOCUMENT_ROOT'];
	$dest_dossier = $chemin_dossier_image.'/';
	
	$dest_fichier = substr(strrchr($img_web, '/'), 1);
	
	$itisimg = 1; //c'est une image (initialisation de la variable)
	
	//le champ champ d'envoie est-il vide ?
	if($img_web == null)
	{
		$msgerreur = "[Attention] Le champ d'envoi est vide !";
		$itisimg = 0;
	}
	
	// vérifications de l'extention
	elseif( !in_array( substr(strrchr($dest_fichier, '.'), 1), $extensions_ok ) )
	{
		$msgerreur = "[Erreur]    N'est pas un fichier de type png, gif ou jpg !";
		$itisimg = 0;
	}
	
	// si c'est une image copy et reduction de l'image
	if($itisimg == 1)
	{
		$orig = $dest_dossier . $dest_fichier;
		if (!copy($img_web, $orig)) 
		{	echo "La copie du fichier $img_web n'a pas réussi...\n";	}
		// creation de la miniature
		$min = $dest_dossier.'mini_'.$dest_fichier;
		miniature($orig, $min,$min_reso_H,$min_reso_V);
		// reduction de l'original si nececaire
		if ($reduct_orig=="checked")
		{
			$origtmp = $dest_dossier.'tmp_'.$dest_fichier;
			miniature($orig, $origtmp,$orig_reso_H,$orig_reso_V);
			unlink($orig);
			rename($origtmp,$orig);
			unlink($origtmp);
		}
		//modif des permissions	
		chmod ($orig,0644);
		chmod ($min,0644);
		lien($orig,$min);
	}
	else {echo $msgerreur;}
}

/*** Creation des liens et affichage de ceux-ci ***/
function lien($orig, $min)
{
	global $img_click, $chemin_dossier_image,
		/*Code wiki*/ $code_wiki_gauche, $code_wikiclick_gauche, $code_wiki_droite, $code_wikiclick_droite, $code_wiki_centre, $code_wikiclick_centre, $code_wiki_caract, $code_wikiclick_caract,
		/*code HTML*/ $code_html_gauche, $code_htmlclick_gauche, $code_html_droite, $code_htmlclick_droite, $code_html_centre, $code_htmlclick_centre, $code_html_caract, $code_htmlclick_caract;
		
	$min  = dc_app_url.'/'.$chemin_dossier_image.'/'.substr(strrchr($min, '/'), 1);
	$orig = dc_app_url.'/'.$chemin_dossier_image.'/'.substr(strrchr($orig, '/'), 1);
	$texte = addslashes(add_quotes($_POST['texte']));
	if ($_POST['mode_album'])
	{
		$album = $_POST['album'];
	} else {
		$album = "LIGHT";
	}
	
	//Insertion en HTML
	if ($_POST['format']=="html_gauche")
	{
		if ($img_click)
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_htmlclick_gauche);	}
		else
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_html_gauche);	}
	}
	else if ($_POST['format']=="html_droite")
	{		
		if ($img_click)
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_htmlclick_droite);	}
		else
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_html_droite);	}
	}
	else if ($_POST['format']=="html_centre")
	{		
		if ($img_click)
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_htmlclick_centre);	}
		else
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_html_centre);	}
	}
	else if ($_POST['format']=="html_caract")	//Insertion html image comme caractère
	{
		if ($img_click)
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_htmlclick_caract);	}
		else
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_html_caract);	}
	} 
	//Insertion en WIKI
	else if ($_POST['format']=="wiki_gauche")
	{		
		if ($img_click)
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_wikiclick_gauche);	}
		else
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_wiki_gauche);	}
	}
	else if ($_POST['format']=="wiki_droite")
	{		
		if ($img_click)
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_wikiclick_droite);	}
		else
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_wiki_droite);	}
	}
	else if ($_POST['format']=="wiki_centre")
	{		
		if ($img_click)
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_wikiclick_centre);	}
		else
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_wiki_centre);	}
	}
	else if ($_POST['format']=="wiki_caract")
	{		
		if ($img_click)
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_wikiclick_caract);	}
		else
		{	$lien = str_replace(array('%min%','%orig%','%texte%','%album%'), array($min,$orig,$texte,$album), $code_wiki_caract);	}
	}


	?>
	
	<script type="text/javascript" src="../../js/toolbar.js"></script>
	<script type="text/javascript">
		if (document.getElementById) {
			var tbImg = new dcToolBar(window.opener.document.getElementById('p_content'),
			window.opener.document.getElementById('p_format'),'images/');
		}
		tbImg.insImgClick('<?php echo $lien?>');
		window.close();
	</script>
	<?php
}

/*** Lien retour ***/
function retour()
{
	?><p style="text-align : center; vertical-align : bottom;"><a href="clickimage.php?format=<?php echo $_GET['format']?>">[retour]</a></p><?php
}

/*** En fonction de l'activation des magic_quotes_gpc protège ou non la chaine de caractères ***/
function add_quotes($chaine)
{
	if (get_magic_quotes_gpc())
	{
		return str_replace("\'","\\\\\'",$chaine);
	} else {
		return str_replace("\'","\\\\\'",addslashes($chaine));
	}
}

/*** Suppresion des fichiers de configuration ***/
function config_old()
{
	global $dir_clickimage;

	if ($_POST['suppr_config_old'])
	{
		foreach (glob("$dir_clickimage*.old") as $file_a_suppr) 
		{
			unlink($file_a_suppr);
		}
	}
	
	if ($config_old = glob("$dir_clickimage*.old"))
	{
		$nb_config_old = count($config_old);
		if ($nb_config_old==1)	{$fichier=" fichier";  $cefichier="ce fichier";  } //singulier
		else/*$nb_config_old>1*/{$fichier=" fichiers"; $cefichier="ces fichiers";} //pluriel
		
		return 'Il y a '.$nb_config_old.$fichier.' sauvegarde du fichier de configuration <INPUT type="submit" name="suppr_config_old" value="Supprimer '.$cefichier.'">';
	}
}

/*** Prendre la valeur de la variable au lieu du formulaire si on charge une préconfiguration ***/
function postORvar($post,$var)
{
	global $preconfig;
	
	if ($preconfig == 1)	{	
		return $var;
	} else {
		return add_quotes ($_POST[$post]);	
	}
}

/*** Sauvegarder les preférences du popup ***/
function save_pref()
{
	global $auteur, $save_pref;
	
	if ($save_pref == "checked")
	{
		if ($_POST['mode_album'])	{
			$lightbox_checked = 'checked';
		} else {
			$lightbox_checked = '';
		}
		//Sauvegarde dans un fichiers
		if (! touch(dirname(__FILE__).'/save_pref_'.$auteur.'.php'))
		{
			echo '<p style=" color:red;"><u style="text-decoration:blink;">/!\</u>
				le fichier d\'enregistrement <code>/ecrire/tools/clickimage/save_pref.php</code> n\'est pas accessible, la configuration n\'a pas pu &ecirc;tre enregistr&eacute;e</p>
				<p>Vous pouvez soit <lo>
				<li>changer les permissions de son dossier (chmod 666)</li>
				<li>D&eacute;sactiv&eacute; l\'enregistrement dans les options du plugin</li>
				</lo></p>';
		} else {
			$fichier_config=fopen(dirname(__FILE__).'/save_pref_'.$auteur.'.php',"w");
			fwrite($fichier_config,'
				<?php
				$format = \''.add_quotes($_POST['format']).'\';
				$lightbox_checked = \''.$lightbox_checked.'\';
				$lightbox_album =\''.addslashes(add_quotes($_POST['album'])).'\';
				?>');
			fclose($fichier_config);
		}
	}
}
			
function formatselected($option)
{
	global $format;
	if ($format==$option)
	{	return "selected";	}
}		

/*** Copie/restauration du fichier de configuration ***/
function cp_fichier_config()
{
	if ($_POST['copie'])
	{
		//Copie du fichier "config.php" dans "share/configclickimage.php"
		@unlink ("../share/configclickimage.php");
		copy (dirname(__FILE__)."/config.php","../share/configclickimage.php");
		return '<p style="color:green;"><span style="text-decoration:blink underline;">/!\</span>Le fichier de configuration à été copier dans le fichier <code>'.dc_app_url.'/share/configclickimage.php</code> !</p>';
	}
	elseif ($_POST['restauration'])
	{
		//Restauration du fichier "config.php" a partire de "share/configclickimage.php"
		if (!file_exists("../share/configclickimage.php"))
		{
			return '<p style="color:red;"><span style="text-decoration:blink underline;">/!\</span> Le fichier de restauration <code>'.dc_app_url.'/share/configclickimage.php</code> n\'existe pas. Restauration impossible !</p>';
		}
		else
		{
			unlink (dirname(__FILE__)."/config.php");
			copy ("../share/configclickimage.php",dirname(__FILE__)."/config.php");
			chmod (fopen(dirname(__FILE__)."/config.php"),0644);
			return '<p style="color:green;"><span style="text-decoration:blink underline;">/!\</span> Le fichier de configuration à été restauré à partir du fichier <code>'.dc_app_url.'/share/configclickimage.php</code> !</p>';
		}
	}
}
?>
